/*
Copyright (c) 2019-2020 Péter Magyar

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef WORLD_GENERATOR_PROP_DATA_H
#define WORLD_GENERATOR_PROP_DATA_H

#include "core/resource.h"

#ifdef VOXELMAN_PRESENT
#include "../../voxelman/props/prop_data.h"
#endif

class WorldGeneratorPropData : public Resource {
	GDCLASS(WorldGeneratorPropData, Resource);

public:
	bool can_spawn(int seed);

#ifdef VOXELMAN_PRESENT
	Ref<PropData> get_prop();
	void set_prop(Ref<PropData> value);

	Ref<PropData> get_prop_seeded(int seed);
#else
	Ref<Resource> get_prop();
	void set_prop(Ref<Resource> value);

	Ref<Resource> get_prop_seeded(int seed);
#endif

	WorldGeneratorPropData();
	~WorldGeneratorPropData();

protected:
	static void _bind_methods();

#ifdef VOXELMAN_PRESENT
	Ref<PropData> _prop;
#else
	Ref<Resource> _prop;
#endif
};

#endif
